/*
 * Copyright
 *   2009 axYus - www.axyus.com
 *   2009 C.Marchand - christophe.marchand@axyus.com
 *
 * This file is part of XEMELIOS.
 *
 * XEMELIOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * XEMELIOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with XEMELIOS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package fr.gouv.finances.dgfip.xemelios.web.navigate;

import fr.gouv.finances.dgfip.xemelios.web.gwt.server.service.ExportResult;
import fr.gouv.finances.dgfip.xemelios.web.utils.StdDispatchAction;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 *
 * @author chm
 */
public class GetExportResult extends StdDispatchAction {

    @Override
    protected ActionForward unspecified(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
        String searchSessionId = request.getParameter("searchSessionId");
        if(searchSessionId==null || searchSessionId.length()==0) {
            request.setAttribute("error.message","parameter searchSessionId expected");
            return mapping.findForward("simple.error");
        }
        ExportResult er = (ExportResult)request.getSession().getAttribute("export-"+searchSessionId);
        if(er==null) {
            request.setAttribute("error.message","session attribute export-"+searchSessionId+" expected");
            return mapping.findForward("simple.error");
        } else {
            if(er.getMimeType()!=null) {
                response.setContentType(er.getMimeType());
                String ext = null;
                for(String key:ViewAttachmentAction.MIME_TYPES.keySet()) {
                    if(ViewAttachmentAction.MIME_TYPES.get(key).equals(er.getMimeType())) {
                        ext = key;
                        break;
                    }
                }
                if(ext!=null) {
                    response.addHeader("Content-disposition", "attachment; filename=export."+ext);
                }
            }
            response.setContentLength(er.getBuffer().length);
            response.getOutputStream().write(er.getBuffer());
            response.getOutputStream().flush();
            request.getSession().removeAttribute("export-"+searchSessionId);
        }
        return null;
    }


}
